//!	XiAudioControler.cpp
//!	XiAudioCodec Control Class.
//!	$Revision: $
//	@author	(C) Arle - wk
//	@note	Ql(IWi):http://kaedeps2.at.infoseek.co.jp/
//
#include "stdafx.h"
#include "XiAudioControler.h"

//	}NB
inline 
int32_t getPCM6( const int32_t *pcm1, int32_t *pcm2, int shiftbit, uint8_t data)
{
	int32_t a1, a2;
	a1 = ( pcm1[0] * pcm2[0] + pcm1[1] * pcm2[1] ) >> 6;
	a2 = ( (int16_t)( data << 12 ) ) >> shiftbit;
	a1 = a1 + a2;
	pcm2[1] = pcm2[0];
	pcm2[0] = a1;
	return pcm2[0];
}

//	ȉANX̎B

//!	RXgN^B
CXiAudioControler::CXiAudioControler(void)
{
}

//!	fXgN^B
CXiAudioControler::~CXiAudioControler(void)
{
}

//!	TvO[g߂B
//	@return	TvO[gB
int CXiAudioControler::getSamplePerSec()
{
	return ( m_xiHeader.Sample1 + m_xiHeader.Sample2 ) & 0x7FFFFFFF;
}

//!	[vĂ邩ǂB
//	@return	[vĂΐ^B
bool CXiAudioControler::hasLoop()
{
	return ( m_xiHeader.LoopPos < m_xiHeader.DataCount );
}

//!	[vJnʒu߂B
//	@return	[vJnʒuB
uint32_t CXiAudioControler::getLoopIndex()
{
	return ( hasLoop() ? m_xiHeader.LoopPos : 0 );
}

//!	k`ǂB
//	@return		k`Ȃ^B
bool CXiAudioControler::isComplessed()
{
	//	Header  Type == 0 ňk`B
	return ( m_xiHeader.Type == 0 );
}

//!	oCg߂B
//	@return	oCgB
uint32_t CXiAudioControler::getDataCount()
{
	return m_xiHeader.DataCount;
}

//!	oCg߂B
//	@param	loop	[v񐔁B
//	@return	oCgB
uint32_t CXiAudioControler::getDataCount( int loop )
{
	return m_xiHeader.DataCount + ( m_xiHeader.DataCount - getLoopIndex() ) * loop;
}

//!	f[^̊Jnʒu߂B
//	@param	index	JnCfbNXB
//	@return	ItZbgB
uint32_t CXiAudioControler::getDataOffset( int index )
{
	return m_xiHeader.DataOffset + getDataSize( index );
}

//!	Tv̒߂B
//	@return	Tv̒B
uint32_t CXiAudioControler::getSampleLength()
{
	return m_xiHeader.SampleLength;
}

//!	Wavef[^փRs[B
//	@param	count	f[^B(t@C̏ۂ)
//	@param	src		Rs[B
//	@param	dst		Rs[B
//	@return	̃Rs[|C^B
uint8_t* CXiAudioControler::toWaveData( int count, uint8_t *src, uint8_t *dst )
{
	int wav_size = getWaveDataSize( count );

	//	kĂȂ΂̂܂܃RsB
	if( !isComplessed() )
	{
		memcpy( dst, src, wav_size );
		return dst += wav_size;
	}

	//	16bit ȊO̓T|[gȂB
	if( m_xiHeader.BitsPerSample != 16 )
		return 0;

	//	f[^1WAVEf[^TCY߂B
	int one_wave_size = getWaveDataSize( 1 );

	for ( int ofs = 0; ofs < count; ofs++ )
	{
		//	`l擾B
		int ch_count = m_xiHeader.Channels;

		//	PCM`ŃRs[B
		for( int ch = 0; ch < ch_count; ch++ )
		{
			const int32_t * pcm = &tblPCM[ *src >> 4 ][0];

			int shiftbit = ( *src & 0xf );

			src++;

			uint16_t *dstptr = (uint16_t*)dst;

			dstptr += ch;
			for ( int i = 0; i < m_xiHeader.SampleLength; i += 2 )
			{
				dstptr[0] = (uint16_t)getPCM6( pcm, &m_buffer[ch][0], shiftbit, ( *src & 0x0F ) >> 0 );
				dstptr[ch_count] = (uint16_t)getPCM6( pcm, &m_buffer[ch][0], shiftbit, ( *src & 0xF0 ) >> 4 );
				dstptr += ch_count * 2;
				src++;
			}
		}

		//	Rs[̃|C^TCYi߂ĂB
		dst += one_wave_size;

	}

	return dst;
}


//!	wb_ݒ肷B(SPW)
//	@param	head	o͐B
//	@return	ہB
bool CXiAudioControler::setXiSoundHeader( const XiSoundHeader & head )
{
	if ( memcmp( head.Magic, "SeWave\0\0", sizeof( head.Magic ) != 0 ) )
		return false;

	m_xiHeader = head;

	return checkData();
}

//!	wb_ݒ肷B(BGW)
//	@param	head	o͐B
//	@return	ہB
bool CXiAudioControler::setXiMusicHeader( const XiMusicHeader & head )
{
	if ( memcmp( head.Magic, "BGMStream\0\0\0\0", sizeof( head.Magic ) != 0 ) )
		return false;

	memset( &m_xiHeader, 0, sizeof( m_xiHeader ) );
    
	m_xiHeader.Type = head.Type;
    m_xiHeader.Size = head.Size;
    m_xiHeader.Index = head.Index;
    m_xiHeader.DataCount = head.DataCount;
    m_xiHeader.LoopPos = head.LoopPos;
    m_xiHeader.Sample1 = head.Sample1;
    m_xiHeader.Sample2 = head.Sample2;
    m_xiHeader.DataOffset = head.DataOffset;
    m_xiHeader.Volume = head.Volume;
    m_xiHeader.BitsPerSample = head.BitsPerSample;
    m_xiHeader.Channels = head.Channels;
    m_xiHeader.SampleLength = head.SampleLength;

	return checkData();
}

//!	ݒ肳ꂽwb_ě؁B
//	@return	^UB
bool CXiAudioControler::checkData()
{
	//	񂪂ȂB
	if ( m_xiHeader.SampleLength == 0 )
		return false;

	//	`l͑ÓB
	if ( m_xiHeader.Channels <= 0 || m_xiHeader.Channels > XI_CHANNEL_MAX )
		return false;

	//	TvO[g傫ȂB
	if ( getSamplePerSec() > XI_SAMPLE_MAX )
		return false;

	//	[vʒu͈͓ɂ邩B
	if ( m_xiHeader.LoopPos != ~0 && m_xiHeader.LoopPos >= m_xiHeader.DataCount )
		return false;

	//	ItZbgwb_TCYȂĂ蓾ȂB
	if ( m_xiHeader.DataOffset >= m_xiHeader.Size )
		return false;

	//	TvO[g8̔{̂͂B
	if ( ( m_xiHeader.BitsPerSample % 8 ) != 0 )
		return false;

	//	Tṽ`FbNB
	if ( isComplessed() )
	{
		if( ( m_xiHeader.SampleLength & 1 ) != 0 )
			return false;

		//	16bit ȊÖk`͂Ȃ͂B
		if( m_xiHeader.BitsPerSample != 16 )
			return false;
	}
	else
	{
		if( m_xiHeader.SampleLength != 1 )
			return false;
	}

	//	܂ł炫ƑÓ낤B
	return true;
}

//!	WAVE`ɏóB
//	@param	format	o͐B
//	@return	ہB
bool CXiAudioControler::exportWaveFormat( WAVEFORMATEX &format )
{
	if( !checkData() )
		return false;
		
	format.cbSize = sizeof( WAVEFORMATEX );
	format.wFormatTag = WAVE_FORMAT_PCM;
	format.nChannels = m_xiHeader.Channels;
	format.nSamplesPerSec = getSamplePerSec();
	format.wBitsPerSample = m_xiHeader.BitsPerSample;

	format.nBlockAlign = format.nChannels * format.wBitsPerSample / 8;
	format.nAvgBytesPerSec = format.nSamplesPerSec * format.nBlockAlign ;
	
	return true;
}

//!	WAVE`́B
//	@param	format	́B
//	@return	ہB
bool CXiAudioControler::importWaveFormat( const WAVEFORMATEX &format )
{
	//	B

	return false;
}

//!	obt@NAB
void CXiAudioControler::clearBuffer()
{
	memset( m_buffer, 0, sizeof( m_buffer ) );
}

//!	f[^TCY擾B
//	@param	count	f[^B
//	@return	f[^TCYB
uint32_t CXiAudioControler::getDataSize( int count )
{
	return count * ( ( ( m_xiHeader.SampleLength * 8 + 15) / ( 1 << 4 ) ) + 1 ) * m_xiHeader.Channels;
}

//!	KvWavef[^̃TCY߂B
//	@param	count	f[^B
//	@return	f[^TCYB
uint32_t CXiAudioControler::getWaveDataSize( int count )
{
	if ( isComplessed() )
		return count * m_xiHeader.SampleLength * ( m_xiHeader.BitsPerSample / 8 ) * m_xiHeader.Channels;
	else
		return getDataSize( count );
}

//!	f[^NAB
void CXiAudioControler::reset()
{
	clearBuffer();
	memset( &m_xiHeader, 0, sizeof( m_xiHeader ) );
}

