//!	XiAudioControler.h
//!	XiAudioCodec Control Class.
//!	$Revision: $
//	@author	(C) Arle - wk
//	@note	Ql(IWi):http://kaedeps2.at.infoseek.co.jp/
//
#ifndef __XI_AUDIO_CONTROLER__
#define	__XI_AUDIO_CONTROLER__

#include "xiac.h"

class CXiAudioControler
{
public:
	CXiAudioControler(void);
	virtual ~CXiAudioControler(void);

//	Private Definitions.
private:
	XiSoundHeader	m_xiHeader;
	int32_t			m_buffer[XI_CHANNEL_MAX][2];

//	Public Definitions.
public:
	bool setXiSoundHeader( const XiSoundHeader & header );
	bool setXiMusicHeader( const XiMusicHeader & header );
	bool checkData();

	bool exportWaveFormat( WAVEFORMATEX &format );
	bool importWaveFormat( const WAVEFORMATEX &format );

	int getSamplePerSec();
	bool hasLoop();
	bool isComplessed();

	uint32_t getLoopIndex();
	uint32_t getDataCount();
	uint32_t getDataCount( int loop );
	uint32_t getDataOffset( int index );
	uint32_t getSampleLength();
	uint32_t getDataSize( int index );
	uint32_t getWaveDataSize( int index );

	uint8_t* toWaveData( int count, uint8_t *src, uint8_t *dst );

	void clearBuffer();
	void reset();
};

//	PCMf[^ւ̕ϊe[uB
static const int32_t
tblPCM [16][2] = {
	{0,0},
	{60,0},
	{115,-52},
	{98,-55},
	{122,-60},
};

#endif