//!	xi2wav.cpp
//!	XiAudioCodec(bgw,spw)wave`ɕϊ̂łB
//!	$Revision: $
//	@author	(C) Arle - wk

#include "stdafx.h"
#include "XiAudioControler.h"

#define	TXT_STARTUP	"xi2wav [version 1.21]\n(C) 2006 Arle - WK\n"
#define	TXT_USEAGE	"USEAGE:\n\txi2wav [ Input File(*.bgw,*.spw) | Output File(*.wav) | [loop count] ]\n"

using namespace std;

enum XiaType { eUNKNOWN, eBGW, eSPW };

//!	XiAudioBGWSPW𔻒肷B
inline
XiaType getXiaType( char * hd )
{
	const char H_BGW [] = { 'B', 'G', 'M', 'S', 't', 'r', 'e', 'a', 'm' };
	const char H_SPW [] = { 'S', 'e', 'W', 'a', 'v', 'e' };

	if ( memcmp( hd, H_BGW, 9 ) == 0 )
		return eBGW;
	else if ( memcmp( hd, H_SPW, 6 ) == 0 )
		return eSPW;
	else
		return eUNKNOWN;
}

//!	WAVE`t@CóB
uint32_t saveToWaveFile( char * filename, WAVEFORMATEX *wfx, WAVEHDR *whdr )
{
	const char HD_RIFF [] = { 'R', 'I', 'F', 'F' };
	const char HD_WAVE [] = { 'W', 'A', 'V', 'E' };
	const char HD_DATA [] = { 'd', 'a', 't', 'a' };
	const char CHK_FMT [] = { 'f', 'm', 't', ' ' };

	//	TCY (wb_TCY(44)) + (f[^TCY) - (RIFFƃTCŸ敪(8))
	uint32_t total_size = ( 44 + whdr->dwBufferLength ) - 8;
	
	//	݃f[^쐬B
	std::vector<uint8_t>  output_data;
	output_data.resize( total_size + 8 );

	uint32_t offset = 0;

	//	RIFFwb_B
	memcpy( &output_data[offset], HD_RIFF, 4 );
	offset += 4;

	//	TCYB
	memcpy( &output_data[offset], &total_size, 4 );
	offset += 4;

	//	WAVEwb_B
	memcpy( &output_data[offset], HD_WAVE, 4 );
	offset += 4;

	//	fmt`NB
	memcpy( &output_data[offset], CHK_FMT, 4 );
	offset += 4;

	//	PCMWAVEFORMAT̃oCgB
	uint32_t pcmf_size = 16;
	memcpy( &output_data[offset], &pcmf_size, 4 );
	offset += 4;

	//	PCMWAVEFORMATf[^B
	memcpy( &output_data[offset], wfx, pcmf_size );
	offset += pcmf_size;

	//	f[^wb_B
	memcpy( &output_data[offset], HD_DATA, 4 );
	offset += 4;

	//	f[^TCYB
	uint32_t data_size = whdr->dwBufferLength;
	memcpy( &output_data[offset], &data_size, 4 );
	offset += 4;

	//	WAVEf[^{́B
	memcpy( &output_data[offset], whdr->lpData, data_size );
	offset += data_size;

	//	I_(TCY + 8)Ɠ͂B
	if ( total_size + 8 != offset )
	{
		return 0;
	}

	//	t@CɏށB
	FILE * ofp = fopen( filename, "wb" );

	try
	{
		//	݃TCYƃf[^TCYvȂꍇ͉ρB
		if ( fwrite( &output_data[0], 1, offset, ofp ) != offset ) 
		{
			throw 0;
		}
	}
	catch( ... )
	{
		fclose( ofp );
		return 0;
	}

	fclose( ofp );

	//	񂾃TCYԂB
	return offset;
}

//!	CB
int _tmain( int argc, _TCHAR* argv[] )
{
	cout << TXT_STARTUP << endl;

	//	2B
	//	0Ԗڂ͎st@C̖OȂ̂3Ń`FbNB
	if ( argc < 3 )
	{
		cout << TXT_USEAGE << endl;
		return 0;
	}

	//	t@CpX擾B
	char * input_file = argv[1];	//	1
	char * output_file = argv[2];	//	2
	
	//	̓t@CȂΏIB
	if ( !::PathFileExistsA( input_file ) )
	{
		cout << "̓t@CȂB\n" << endl;
		return 0;
	}

	size_t dst_len = strlen( output_file );
	std::vector<char> dst_dir;
	dst_dir.resize( dst_len + 1 );

	//	o̓fBNg`FbNB
	strcpy( &dst_dir[0], output_file );
	dst_dir.push_back( 0 );
	if ( !::PathRemoveFileSpecA( &dst_dir[0] ) )
	{
		cout << "o͐̎w肪ς݂B\n" << endl;
		return 0;
	}
	
	if ( !::PathIsDirectoryA( &dst_dir[0] ) )
	{
		cout << "o͐̃fBNgȂ݂B\n" << endl;
		return 0;
	}


	//	o͂Ƃ炵̂ŕϊJnB
	cout << "f[^ϊ...\n" << endl;

	//	XiAudioControler 쐬B
	CXiAudioControler* xic = new CXiAudioControler();

	try
	{
		//	̓t@CJB
		FILE * ifp = fopen( input_file, "rb" );

		try
		{
			//	̓t@C̃TCY擾B
			fseek( ifp, 0L, SEEK_END );
			long input_size = ftell( ifp );
			fseek( ifp, 0L, SEEK_SET );

			//	̓obt@B
			std::vector<uint8_t>  input_data;
			input_data.resize( input_size );

			//	ǂݍށB
			if ( fread( (uint8_t*)(&input_data[0]), 1, input_size, ifp ) < 0 )
			{
				//	input_size ̏ꍇ͎sB
				throw 0;
			}

			//	A9byteĂƂ͂ȂB
			if ( input_size < 9 )
			{
				throw 0;
			}	

			//	wb_ǂݍށB
			std::vector<uint8_t>  input_head;
			int head_size = sizeof( XiSoundHeader );
			input_head.resize( head_size );

			memcpy( &input_head[0], &input_data[0], head_size );

			//	BGWSPW𔻒B
			XiaType xt = getXiaType( (char*)(&input_head[0]) );

			//	͏̍\̂𗼕ƂB
			//	ĝ͂ǂЂƂB
			XiMusicHeader xmh;
			XiSoundHeader xsh;

			//	tH[}bgB
			switch( xt )
			{
				case eBGW:
					memcpy( &xmh, (uint8_t*)(&input_head[0]), sizeof( XiMusicHeader ) );
					xic->setXiMusicHeader( xmh );
					break;
				case eSPW:
					memcpy( &xsh, (uint8_t*)(&input_head[0]), sizeof( XiSoundHeader ) );
					xic->setXiSoundHeader( xsh );
					break;
				default:
					//	sȃwb_B
					throw 0;
					break;
			}

			//	f[^Af[^̐擪ʒuAg`f[^TCY擾B
			uint32_t data_count = xic->getDataCount();
			uint32_t data_offset = xic->getDataOffset( 0 );
			uint32_t wave_data_size = xic->getWaveDataSize( data_count );

			//	o͐̍\́B
			WAVEFORMATEX	output_head;
			WAVEHDR			output_data;

			//	WAVE`̃wb_擾B
			xic->exportWaveFormat( output_head );

			//	WAVE`̃f[^TCY擾B
			output_data.dwBufferLength = wave_data_size;

			//	o̓obt@B
			std::vector<uint8_t>  wave_data;
			wave_data.resize( wave_data_size );

			//	g`f[^XiAudio`PCM`ɕϊB
			xic->toWaveData( data_count, &input_data[data_offset], &wave_data[0] );
			output_data.lpData = (LPSTR)(&wave_data[0]);

			//	t@CɏóB
			if ( saveToWaveFile( output_file, &output_head, &output_data ) == 0 )
			{
				//	߂ȂB
				throw 0;
			}

		}
		catch( ... )
		{
			fclose( ifp );
			throw 0;
		}

		fclose( ifp );
	}
	catch( ... )
	{
		cout << "߂BB\n" << endl;
		delete xic;

		return 0;
	}

	delete xic;

	cout << "ϊI" << endl;
	cout << "\t'" << output_file << "' ɕۑ܂B" << endl;

	return 0;
}

